///////////////////////////////////////////////////////////////////
// The Init function is called when bric is first selected       //
// Use it to make changes to the initial state of the sidebar UI //
///////////////////////////////////////////////////////////////////


function init(bricVersion,framework)
{
	window.webkit.messageHandlers.debug.postMessage("Mail Chimp Bric Version = "+bricVersion);
	window.webkit.messageHandlers.debug.postMessage("FrameWork = "+framework);
	
	// Check If Form Has Title
	if(!checkFormHasTitle())
	{
		window.webkit.messageHandlers.setUIState.postMessage('{"attr":"mail-chimp-form-title","enable":"'+enableTitleField+'"}'); // Disable Title Field
	}
}


//////////////////////
// Custom Functions //
//////////////////////


// Set Mail Chimp Form URL
function setMailChimpURL(V)
{
	$('editarea form').attr('action',V);
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Toggle Include Form Title
function toggleIncludeFormTitle(V)
{
	var enableTitleField = false;
	
	if(V == 0) // Hide Title
	{
		$('editarea form h2').remove();
		window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"mail-chimp-form-title","value":"","sync":"true"}'); // Clear Title Field
	}
	else // Show Title
	{	
		enableTitleField = true;	
		if ($('editarea form h2').length == 0) // Only add if no title
		{
			$('editarea form').find('#mc_embed_signup_scroll').prepend('<h2>Subscribe to our mailing list</h2>');
			window.webkit.messageHandlers.setUIVal.postMessage('{"attr":"mail-chimp-form-title","value":"Subscribe to our mailing list","sync":"true"}'); // Clear Title Field
		}
	}
	
	window.webkit.messageHandlers.setUIState.postMessage('{"attr":"mail-chimp-form-title","enable":"'+enableTitleField+'"}'); // Enable Title Field
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Check Form has Title
function checkFormHasTitle()
{
	var hasTitle = false;
	
	if ($('editarea form h2').length > 0)
	{
		hasTitle = true;
	}
	
	return hasTitle;
}


// Set Form title
function setFormTitle(V)
{
	$('editarea form h2').text(V);
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Toggle Required Fields
function toggleRequiredFields(V)
{
	if(V == 0) // Show All Fields
	{
		$('<div class="mc-field-group"><label for="mce-FNAME">First Name </label><input type="text" value="" name="FNAME" class="" id="mce-FNAME"></div>').insertAfter('.mc-field-group')
	}
	else // Show Only Requested Fields
	{
		$('.mc-field-group').eq(1).remove();
	}
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Toggle Requested Fields Indicators
function toggleRequiredIndicators(V)
{
	if(V == 0) // Hide
	{
		$('.indicates-required, .asterisk').remove();
	}
	else // Show
	{
		// Add Alterisk Notice
		$('<div class="indicates-required"><span class="asterisk">*</span> indicates required</div>').insertAfter('form h2').eq(0);
		
		// Add Alterisk To Email Label
		var emailLabel = $('label[for="mce-EMAIL"]');
		emailLabel.html(emailLabel.text()+'<span class="asterisk">*</span></label>');
	}
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}

// Toggle Form JS
function toggleFormJS(V)
{	
	if(V == 0) // Dont Include JS
	{
		$('editarea script[type="text/javascript"]').remove();
	}
	else // Include JS
	{
		$("<script type='text/javascript' src='https://s3.amazonaws.com/downloads.mailchimp.com/js/mc-validate.js'></script><script type='text/javascript'>(function($) {window.fnames = new Array(); window.ftypes = new Array();fnames[0]='EMAIL';ftypes[0]='email';fnames[1]='FNAME';ftypes[1]='text';}(jQuery));var $mcj = jQuery.noConflict(true);</script>").insertAfter('#mc_embed_signup');
	}
	window.webkit.messageHandlers.sync.postMessage("changes"); // Sync Changes
}